#!/usr/bin/expect -f

set timeout -1

set prompt "#"
set address [lindex $argv 0]
set adapter_address [lindex $argv 1]

#spawn bluetoothctl -a #for old version

spawn bluetoothctl

expect -re $prompt
send "select $adapter_address\r"
send "trust $address\r"

set result_code -1
set connection_attemps 0
while {$connection_attemps < 10} {
    send "connect $address\r"
    expect {
        "Connection successful" {
            set result_code 0
            break
        }
        "Failed to connect" {
            incr connection_attemps
            sleep 1
        }
    }
}
send "quit\r"
expect eof

if { $result_code != 0 } {
    exit $result_code
}

set result_code -1
set bluez_checking_attemps 0
while {$bluez_checking_attemps < 3} {
    spawn pactl list cards short
    expect {
        -re {(\d+)\t+bluez} {
            set card_idx $expect_out(1,string)
            expect eof
            set result_code 0
            puts "bluez card was found: $card_idx\r"

            spawn pactl set-card-profile $card_idx a2dp_sink
            expect eof
            break
        }
        eof {
            incr bluez_checking_attemps
            puts "bluez card was not found\r"
            sleep 2
        }
    }
}

exit $result_code
