#!/bin/bash

echo "stopping brltty"
killall -9 brltty

SPEAKER_MAC=$(cat /home/pi/.config/Sensor-Tech/smart-cane-demo.conf | grep speakerMacAddress | cut -c 19-)

hciconfig | egrep -o 'hci[0-9]+' | while read adapter
do
    echo "Processing adapter $adapter..."

    bt-device -a $adapter -l | grep ")" | rev | cut -d'(' -f 1 | cut -c2- | rev | while read line
    do
        if [ "$SPEAKER_MAC" != "$line" ]
        then
            echo "Unpairing $line..."
            bt-device -a $adapter -r $line
        else
            echo "Skipping active speaker $line..."
        fi
    done
done
