#!/bin/bash

export PATH=$PATH:/usr/bin:/usr/local/bin
export LD_LIBRARY_PATH=/opt/Qt5/lib:/usr/local/lib:$LD_LIBRARY_PATH

LOG_FILE=/tmp/recognition-module-bluetooth-service.log

while :
do
    hciconfig | grep --quiet hci
    if [ $? -eq 0 ]
    then
        hciconfig | grep --quiet UP
        if [ $? -eq 0 ]
        then
            break
        fi
    fi
    echo "Waiting for bluetooth..." >> $LOG_FILE
    sleep 1
done

echo "Bluetooth adapter found" >> $LOG_FILE
hciconfig >> $LOG_FILE

pulseaudio -D

while :
do
    pulseaudio --check
    if [ $? -eq 0 ]
    then
        break
    fi
    sleep 1
    echo "waiting for pulseaudio start..." >> $LOG_FILE
done

echo "Pulseaudio ready" >> $LOG_FILE

while :
do
    dbus-send --system \
              --dest=org.bluez \
              --type=method_call \
              --print-reply \
              /org/bluez \
              org.freedesktop.DBus.Introspectable.Introspect | grep  --quiet AgentManager1
    if [ $? -eq 0 ]
    then
        hciconfig | grep --quiet UP
        if [ $? -eq 0 ]
        then
            break
        fi
    fi
    echo "Waiting for bluez registering on DBus..." >> $LOG_FILE
    sleep 1
done

echo "Bluez registered on DBus" >> $LOG_FILE

while :
do
    remove_paired.sh >> $LOG_FILE 2>&1
    recognition-module-bluetooth-service >> $LOG_FILE 2>&1
    echo "restarting service..."
    sleep 1
done
