#!/bin/bash

export PATH=$PATH:/usr/bin:/usr/local/bin

LOG_FILE=/tmp/smart-cane-demo.log

while :
do
    hciconfig | grep --quiet hci
    if [ $? -eq 0 ]
    then
        hciconfig | grep --quiet UP
        if [ $? -eq 0 ]
        then
            break
        fi
    fi
    echo "Waiting for bluetooth..." >> $LOG_FILE
    sleep 1
done

echo "Bluetooth adapter found" >> $LOG_FILE
hciconfig >> $LOG_FILE

while :
do
    dbus-send --system \
              --dest=org.bluez \
              --type=method_call \
              --print-reply \
              /org/bluez \
              org.freedesktop.DBus.Introspectable.Introspect | grep  --quiet AgentManager1
    if [ $? -eq 0 ]
    then
        hciconfig | grep --quiet UP
        if [ $? -eq 0 ]
        then
            break
        fi
    fi
    echo "Waiting for bluez registering on DBus..." >> $LOG_FILE
    sleep 1
done

echo "Bluez registered on DBus" >> $LOG_FILE

while :
do
    pulseaudio --check
    if [ $? -eq 0 ]
    then
        break
    fi
    sleep 1
    echo "waiting for pulseaudio start..." >> $LOG_FILE
done

echo "Pulseaudio ready" >> $LOG_FILE

while :
do
    remove_paired.sh >> $LOG_FILE 2>&1
    smart-cane-demo >> $LOG_FILE 2>&1
    if [ $? -eq 3 ]; then
        for (( count=1; count<5; count++ ))
        do
            echo "Sending direct local alarm..." >> $LOG_FILE
            sleep 1
            direct-alarm-sender-demo "00:15:83:4C:0D:4D" >> $LOG_FILE
            if [ $? -eq 0 ]; then
                echo "Direct alarm successfully sent" >> $LOG_FILE
                break
            fi
        done
    fi
    echo "restarting demo..." >> $LOG_FILE
    sleep 1
done
