/*
 *  Copyright (c) 2018 LLC LEXY. All rights reserved.
 */

#ifndef __V_DIRECT_ALARM_SENDER_H_
#define __V_DIRECT_ALARM_SENDER_H_

#include <QLowEnergyController>

#include <vnetwork/v_network_global.h>

class VNETWORK_LIBRARY_EXPORT VDirectAlarmSender : public QObject
{
    Q_OBJECT

public:
    VDirectAlarmSender( QObject *parent = nullptr ) noexcept;

    void start( const QBluetoothAddress& destination ) noexcept;

signals:
    void alarmSendingFinished( bool success );

private slots:
    void onConnectedToPeripheral( ) noexcept;
    void onDisconnectedFromPeripheral( ) noexcept;
    void onPeripheralDiscoveryFinished( ) noexcept;
    void onServiceStateChanged( QLowEnergyService::ServiceState newState ) noexcept;
    void onCharacteristicWritten( const QLowEnergyCharacteristic &characteristic,
                                  const QByteArray &newValue) noexcept;
    void onServiceError( QLowEnergyService::ServiceError newError ) noexcept;
    void onControllerError( QLowEnergyController::Error newError ) noexcept;

private:
    Q_DISABLE_COPY( VDirectAlarmSender )

    bool m_alarmSent = false;
    QLowEnergyController *m_centralController = nullptr;
    QLowEnergyService *m_service = nullptr;
    const QBluetoothUuid m_characteristicUuid;
    const unsigned m_commandIndex;
};

#endif
